#! /usr/bin/env perl
use strict;
use warnings;
use autodie;
use Getopt::Long;
use vars qw ($help $inlist $outfile $annotation);

$outfile="junction_table_DIEGO";
GetOptions (
    "l=s"       => \$inlist,
    "h"         => \$help,
    "o=s"       => \$outfile,
    "a=s"       => \$annotation
    );
usage() if ($help || !$inlist|| !$annotation);

open(my $IN, "<", $inlist); 
my @files;
my @names;
my $count=0;
while(<$IN>) {
    my @F=split;
    $names[$count]=$F[0];
    $files[$count]=$F[1];
    $count++;
}
my $filelist=join(" ",@files);
my $headerlist=join("\t",@names);
close($IN);
my %spliceids;
my %numbers;
my $execfile="";
for (my $i=0; $i<=$#files; $i++) {
    $execfile.="  $outfile.tmp.$$.$names[$i]_counter";
    `fgrep -v description $files[$i] |  cut -f 1,2,3 | sort  | uniq -c |  perl -wlane \'print \"\$F[0]\\t\$F[1]:\$F[2]-\$F[3]\" if(\$F[3]>\$F[2]);\' > $outfile.tmp.$$.$names[$i]_counter`;
}
`cut -f 2 $execfile | sort -u >> $outfile.tmp.$$.Splicesitelist`;
$execfile="";
for (my $i=0; $i<=$#files; $i++) {
    `join -a 1  -1 1 -2 2 $outfile.tmp.$$.Splicesitelist $outfile.tmp.$$.$names[$i]_counter | perl -wlane \'if(\$#F<1) {print \"0\"; next;} print \$F[1];\' > $outfile.tmp.$$.$names[$i]_joint`;
    $execfile.=" $outfile.tmp.$$.$names[$i]_joint";
}
`sed -i -r \'s/[:-]/\\t/g\' $outfile.tmp.$$.Splicesitelist`;
`paste $outfile.tmp.$$.Splicesitelist $execfile | sort -V > $outfile.tmp.$$.Splicesitelist.bed`;
`bedtools intersect -F 0.5 -wo -b $outfile.tmp.$$.Splicesitelist.bed -a $annotation > $outfile.tmp.$$.Temporaryjunctions.bed`;

open($IN, "<", "$outfile.tmp.$$.Temporaryjunctions.bed");
open(my $OUT, ">", $outfile);
print $OUT "junction\ttype";
for(my $i=0; $i<=$#names; $i++) {
    print $OUT "\t$names[$i]";
}
print $OUT "\tgeneID\tgeneName\n";
while(<$IN>) {
    chomp;
    my @F=split;
    my @y=split(/;/,$F[3]);
    print $OUT "$F[6]:$F[7]-$F[8]\tN_w";
    for(my $i=9; $i<$#F; $i++) {
	print $OUT "\t$F[$i]";
    }
    print $OUT "\t$y[1]\t$y[2]\n";
}

printf STDERR "You now should have a file $outfile to play with\nThank you for travelling with us, Good bye!\n";
`rm $outfile.tmp.$$.*`;
    
sub usage {
  print STDERR "\npre_segemehl0.3.0.pl\n";
  print STDERR "usage: pre_segemehl.pl -l <file>  [OPTIONS]\n";
  print STDERR "\n";
  print STDERR "[INPUT]\n";
  print STDERR " -l <file>    file containing input files and ids\n \t\tid [tab] path.to/file\n";
  print STDERR " -a <file>    DIEGO-formated annotation file \n";
  print STDERR " -o <file>    output file name (default:junction_table_DIEGO )\n";
  print STDERR " -h <file>    this (usefull) help message\n";
  print STDERR "[VERSION]\n";
  print STDERR " 06-25-2017\n";
  print STDERR "[BUGS]\n";
  print STDERR " Please report bugs to salzamt\@bioinf.uni-leipzig.de\n";
  print STDERR "\n";
  exit(-1);
}

